<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_131) on Mon Jul 17 12:51:56 CEST 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>PlayStrategy (APP)</title>
<meta name="date" content="2017-07-17">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="PlayStrategy (APP)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":9,"i1":9,"i2":9,"i3":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/PlayStrategy.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../towerwarspp/player/PlayerState.html" title="enum in towerwarspp.player"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../towerwarspp/player/RndPlayer.html" title="class in towerwarspp.player"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/player/PlayStrategy.html" target="_top">Frames</a></li>
<li><a href="PlayStrategy.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#enum.constant.summary">Enum Constants</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#enum.constant.detail">Enum Constants</a>&nbsp;|&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">towerwarspp.player</div>
<h2 title="Enum PlayStrategy" class="title">Enum PlayStrategy</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>java.lang.Enum&lt;<a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&gt;</li>
<li>
<ul class="inheritance">
<li>towerwarspp.player.PlayStrategy</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.io.Serializable, java.lang.Comparable&lt;<a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&gt;</dd>
</dl>
<hr>
<br>
<pre>public enum <span class="typeNameLabel">PlayStrategy</span>
extends java.lang.Enum&lt;<a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&gt;</pre>
<div class="block">Class offering enums representing different play strategies and methods that implement those strategies.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== ENUM CONSTANT SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="enum.constant.summary">
<!--   -->
</a>
<h3>Enum Constant Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Enum Constant Summary table, listing enum constants, and an explanation">
<caption><span>Enum Constants</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Enum Constant and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/player/PlayStrategy.html#DYNAMIC">DYNAMIC</a></span></code>
<div class="block">Dynamically change between <a href="../../towerwarspp/player/PlayStrategy.html#LIGHT"><code>LIGHT</code></a> and <a href="../../towerwarspp/player/PlayStrategy.html#HEAVY"><code>HEAVY</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/player/PlayStrategy.html#HEAVY">HEAVY</a></span></code>
<div class="block">Heavy PlayStrategy uses an evaluation function to score moves and randomly chose one of the highest scored ones.</div>
</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/player/PlayStrategy.html#LIGHT">LIGHT</a></span></code>
<div class="block">Light PlayStrategy is equivalent to making moves at random.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static java.util.Random</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/PlayStrategy.html#random">random</a></span></code>
<div class="block">Random instance to generate pseudo random numbers.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static <a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/PlayStrategy.html#heavyPlay-towerwarspp.board.Board-">heavyPlay</a></span>(<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</code>
<div class="block">Uses the passed <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> object to get all moves available to the Player returned by <a href="../../towerwarspp/board/SimpleBoard.html#getTurn--"><code>SimpleBoard.getTurn()</code></a>,
 then assigns a score to each of them by using the <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>Board.altScore(Move, PlayerColor)</code></a> evaluation function
 and returns a random move out of the highest scored moves.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>static <a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/PlayStrategy.html#lightPlay-towerwarspp.board.Board-">lightPlay</a></span>(<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</code>
<div class="block">Uses the passed <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> object to get all moves available to the Player returned by <a href="../../towerwarspp/board/SimpleBoard.html#getTurn--"><code>SimpleBoard.getTurn()</code></a>,
 then randomly selects one of them and returns it.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>static <a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/PlayStrategy.html#valueOf-java.lang.String-">valueOf</a></span>(java.lang.String&nbsp;name)</code>
<div class="block">Returns the enum constant of this type with the specified name.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>static <a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/PlayStrategy.html#values--">values</a></span>()</code>
<div class="block">Returns an array containing the constants of this enum type, in
the order they are declared.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Enum">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Enum</h3>
<code>clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>getClass, notify, notifyAll, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ ENUM CONSTANT DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="enum.constant.detail">
<!--   -->
</a>
<h3>Enum Constant Detail</h3>
<a name="LIGHT">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>LIGHT</h4>
<pre>public static final&nbsp;<a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a> LIGHT</pre>
<div class="block">Light PlayStrategy is equivalent to making moves at random. If an AI Player is employing a LIGHT strategy
 he should use the offered <a href="../../towerwarspp/player/PlayStrategy.html#lightPlay-towerwarspp.board.Board-"><code>lightPlay(Board)</code></a> method.</div>
</li>
</ul>
<a name="HEAVY">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>HEAVY</h4>
<pre>public static final&nbsp;<a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a> HEAVY</pre>
<div class="block">Heavy PlayStrategy uses an evaluation function to score moves and randomly chose one of the highest scored ones.</div>
</li>
</ul>
<a name="DYNAMIC">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>DYNAMIC</h4>
<pre>public static final&nbsp;<a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a> DYNAMIC</pre>
<div class="block">Dynamically change between <a href="../../towerwarspp/player/PlayStrategy.html#LIGHT"><code>LIGHT</code></a> and <a href="../../towerwarspp/player/PlayStrategy.html#HEAVY"><code>HEAVY</code></a>.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="random">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>random</h4>
<pre>private static final&nbsp;java.util.Random random</pre>
<div class="block">Random instance to generate pseudo random numbers.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="values--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>values</h4>
<pre>public static&nbsp;<a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>[]&nbsp;values()</pre>
<div class="block">Returns an array containing the constants of this enum type, in
the order they are declared.  This method may be used to iterate
over the constants as follows:
<pre>
for (PlayStrategy c : PlayStrategy.values())
&nbsp;   System.out.println(c);
</pre></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an array containing the constants of this enum type, in the order they are declared</dd>
</dl>
</li>
</ul>
<a name="valueOf-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>valueOf</h4>
<pre>public static&nbsp;<a href="../../towerwarspp/player/PlayStrategy.html" title="enum in towerwarspp.player">PlayStrategy</a>&nbsp;valueOf(java.lang.String&nbsp;name)</pre>
<div class="block">Returns the enum constant of this type with the specified name.
The string must match <i>exactly</i> an identifier used to declare an
enum constant in this type.  (Extraneous whitespace characters are 
not permitted.)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>name</code> - the name of the enum constant to be returned.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the enum constant with the specified name</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.IllegalArgumentException</code> - if this enum type has no constant with the specified name</dd>
<dd><code>java.lang.NullPointerException</code> - if the argument is null</dd>
</dl>
</li>
</ul>
<a name="lightPlay-towerwarspp.board.Board-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>lightPlay</h4>
<pre>public static&nbsp;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;lightPlay(<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</pre>
<div class="block">Uses the passed <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> object to get all moves available to the Player returned by <a href="../../towerwarspp/board/SimpleBoard.html#getTurn--"><code>SimpleBoard.getTurn()</code></a>,
 then randomly selects one of them and returns it.
 The Board instance is not changed in any way.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>board</code> - board to get available moves from</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>randomly selected move</dd>
</dl>
</li>
</ul>
<a name="heavyPlay-towerwarspp.board.Board-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>heavyPlay</h4>
<pre>public static&nbsp;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;heavyPlay(<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</pre>
<div class="block">Uses the passed <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> object to get all moves available to the Player returned by <a href="../../towerwarspp/board/SimpleBoard.html#getTurn--"><code>SimpleBoard.getTurn()</code></a>,
 then assigns a score to each of them by using the <a href="../../towerwarspp/board/Board.html#altScore-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-"><code>Board.altScore(Move, PlayerColor)</code></a> evaluation function
 and returns a random move out of the highest scored moves.
 The <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> instance is not changed in any way</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>board</code> - board to get moves from</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>randomly selected move out of the highest scored moves</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/PlayStrategy.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../towerwarspp/player/PlayerState.html" title="enum in towerwarspp.player"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../towerwarspp/player/RndPlayer.html" title="class in towerwarspp.player"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/player/PlayStrategy.html" target="_top">Frames</a></li>
<li><a href="PlayStrategy.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#enum.constant.summary">Enum Constants</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#enum.constant.detail">Enum Constants</a>&nbsp;|&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
